// 005 u_oracle_dbx_insert_data
// 04 sep 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com


(*$r+*)
unit u_oracle_dbx_insert_data;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls,
  DBXpress, SqlExpr, FMTBcd, DBClient, Provider;

type
  TForm1 = class(TForm)
    Panel4: TPanel;
    insert_: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    insert_edit_: TButton;
    select_: TButton;
    insert_generic_: TButton;
    insert_batch_dates_: TButton;
    dates_: TButton;
    insert_batch_villes_: TButton;
    villes_: TButton;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    DataSetProvider1: TDataSetProvider;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ClientDataSet1: TClientDataSet;
    procedure FormCreate(Sender: TObject);
    procedure insert_Click(Sender: TObject);
    procedure insert_edit_Click(Sender: TObject);
    procedure select_Click(Sender: TObject);
    procedure insert_generic_Click(Sender: TObject);
    procedure insert_batch_dates_Click(Sender: TObject);
    procedure dates_Click(Sender: TObject);
    procedure insert_batch_villes_Click(Sender: TObject);
    procedure villes_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
    ;

    {$R *.DFM}

  
    const k_root_path= '..\_data\';
          k_batch_path= k_root_path;
            // k_batch_name= 'insert_batch.txt';
            k_batch_dates= 'insert_batch_dates.txt';
            k_batch_villes= 'insert_batch_villes.txt';

          k_select_formations= 'SELECT * FROM formations';
          k_select_dates= 'SELECT * FROM dates';
          k_select_villes= 'SELECT * FROM villes';

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.insert_Click(Sender: TObject);
        // -- hard coded values
      begin
        SqlConnection1.Open;

        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('INSERT INTO formations');
            Add('  (f_numero, f_nom)');
            Add('  VALUES (3, ''Oracle Delphi'')');
          end;

          display_strings(Sql);

          Try
            ExecSql;
            display('  ok');
          except
            on e: Exception do
              display('  *** pb_insert '+ e.Message);
          end;
        end; // with SqlQuery1
      end; // insert_Click

    procedure TForm1.insert_edit_Click(Sender: TObject);
        // -- value from an Edit
      begin
        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('INSERT INTO formations');
            Add('  (f_numero, f_nom)');
            Add('  VALUES (18, '''+ edit1.text+ ''')');
          end;

          display_strings(Sql);

          Try
            ExecSql;
            display('  ok');
          except
            on e: Exception do
              display('  *** pb_insert '+ e.Message);
          end;
        end; // with SqlQuery1
      end; // insert_edit_Click

    // -- batch with individual values

    var g_length_max: Integer= 0;

    procedure insert_generic(p_number: Integer; p_name: String; p_days: Integer; p_cost: Double);
      begin
        // -- used to compute the CHAR size of CREATE TABLE
        if Length(p_name)> g_length_max
          then g_length_max:= Length(p_name);
        // Exit;

        with Form1, SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('INSERT INTO formations');
            Add('  (f_numero, f_nom, f_jours, f_prix)');
            // Add('  (F_NUMERO, F_NOM, F_JOURS, F_PRIX)');
            DecimalSeparator:= '.';
            Add('  VALUES ('+ IntToStr(p_number)+ ', '+ QuotedStr(p_name)
                + ', '+ IntToStr(p_days)+ ', '+ FloatToStr(p_cost)+ ')');
            DecimalSeparator:= ',';
          end;

          display_strings(Sql);

          Try
            ExecSql;
            display('  ok');
          except
            on e: Exception do
              display('  *** pb_insert '+ e.Message);
          end;
        end; // with SqlQuery1
      end; // insert_generic

    procedure TForm1.insert_generic_Click(Sender: TObject);
        // -- values for batch are hard coded
      begin
        insert_generic(1, 'Initiation Delphi', 3, 1400.40);
        insert_generic(2, 'Bases de Donnes Delphi', 3, 1400);
        insert_generic(3, 'Oracle Delphi', 3, 1400);
        insert_generic(4, 'Composants Delphi', 3, 1400);
        insert_generic(5, 'UML et Patterns Delphi', 3, 1400);
        insert_generic(6, 'Initiation Pascal', 4, 1900);
(*
        insert_generic(1, 'Initiation Delphi', 3, 1400.40);
        insert_generic(3, 'Interbase Delphi', 3, 1400);
        insert_generic(5, 'UML et Patterns Delphi', 3, 1400);
*)
        display(IntToStr(g_length_max));
      end; // insert_generic_Click

    // -- batch with field and value strings

    procedure insert_batch(p_table_name, p_field_names, p_field_values: String);
      begin
        with Form1, SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('INSERT INTO '+ p_table_name);
            Add('  ('+ p_field_names+ ')');
            Add('  VALUES ('+ p_field_values+ ')');
          end;

          display_strings(Sql);

          Try
            ExecSql;
            display('  ok');
          except
            on e: Exception do
              display('  *** pb_insert '+ e.Message);
          end;
        end; // with SqlQuery1
      end; // insert_batch

    procedure analyze_batch_and_insert(p_batch_file_name: String);
        // -- read the parameters from a file
        // -- assumes that
        // --   | table_name
        // --   |   field_1_name, field_2_name ...
        // --   |
        // --   | value1 value2 value3 ...
      var l_list_index: Integer;
          l_line, l_trimmed_line: String;
          l_table_name, l_field_names: String;
          l_line_index, l_line_length, l_start_index: Integer;
          l_field_value, l_field_values: String;
      begin
        with tStringList.Create do
        begin
          LoadFromFile(p_batch_file_name);

          l_table_name:= Trim(Strings[0]);
          l_field_names:= Trim(Strings[1]);

          for l_list_index:= 3 to Count- 1 do
          begin
            l_line:= Strings[l_list_index];
            l_trimmed_line:= Trim(l_line);
            if (l_trimmed_line<> '') and (l_trimmed_line[1]<> '/')
              then begin
                  l_line_length:= Length(l_trimmed_line); l_line_index:= 1;
                  l_field_values:= '';
                  while l_line_index<= l_line_length do
                  begin
                    while (l_line_index<= l_line_length) and (l_trimmed_line[l_line_index]= ' ') do
                      Inc(l_line_index);
                    l_field_value:= '';
                    while (l_line_index<= l_line_length) and (l_trimmed_line[l_line_index]<> ' ') do
                    begin
                      l_field_value:= l_field_value+ l_trimmed_line[l_line_index];
                      Inc(l_line_index);
                    end;
                    if l_field_values<> ''
                      then l_field_values:= l_field_values+ ', ';
                    l_field_values:= l_field_values+ l_field_value;
                  end;

                  // display('values '+ l_trimmed_line);
                  display('values '+ l_field_values);
                  insert_batch(l_table_name, l_field_names, l_field_values);
                end;
          end; // for l_list_index
        end; // with tStringList
      end; // analyze_batch_and_insert

    procedure TForm1.insert_batch_dates_Click(Sender: TObject);
      begin
        analyze_batch_and_insert(k_batch_path+ k_batch_dates);
      end; // insert_batch_dates_Click

    procedure TForm1.insert_batch_villes_Click(Sender: TObject);
      begin
        analyze_batch_and_insert(k_batch_path+ k_batch_villes);
      end; // insert_batch_villes_Click

    // -- check with Select

    procedure select(p_query: String);
      var l_count: Integer;
      begin
        with Form1 do
        begin
          ClientDataset1.Close;
          with SqlQuery1 do
          begin
            Close;
            Sql.Text:= p_query;
            Open;
            l_count:= 0;
            While not Eof do
            begin
              Inc(l_count);
              Next;
            end; // while not Eot
            display('  ok, '+ IntToStr(l_count)+ ' lines');
          end; // with SqlQuery1
          ClientDataset1.Open;
        end; // with Form1
      end; // select

    procedure TForm1.select_Click(Sender: TObject);
      begin
        select(k_select_formations);
      end; // select_Click

    procedure TForm1.dates_Click(Sender: TObject);
      begin
        select(k_select_dates);
      end; // select_dates_Click

    procedure TForm1.villes_Click(Sender: TObject);
      begin
        select(k_select_villes);
      end; // villes_Click

end.


